// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
var ionicApp = angular.module('Hopamviet', ['ionic','ngCordova','Hopamviet.config','Hopamviet.controllers','Hopamviet.services', 'Hopamviet.directives']);
var db = null;

ionicApp.run(function($ionicPlatform, $cordovaSQLite , Database , DB_CONFIG) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
	
	console.log("ionicPlatform.ready");
			
	
	if(window.sqlitePlugin !== undefined){
		 window.plugins.sqlDB.copy(DB_CONFIG.name, function() {		
			Database.initDB();
		 }, function(error) {
			console.error("There was an error copying the database: " + error);		
			Database.initDB();
		 });
	}else {
		Database.initDB4WebSQL();
		//Database.preloadDataBase(true);
	}
	
	if(Database.getDB() == null){
		Database.initDB();
	}
	
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })

  .state('app.search', {
    url: '/search',
    views: {
      'menuContent': {
        templateUrl: 'templates/search.html',
		controller: 'SearchCtrl'
      }
    }
  })
  
  
  
  .state('app.results', {
    url: '/results/:txtSearch',
    views: {
      'menuContent': {
        templateUrl: 'templates/results.html',
		controller: 'ResultsCtrl'
      }
    }
  })
  
  .state('app.results_artist', {
    url: '/results/:artistId:type',
    views: {
      'menuContent': {
        templateUrl: 'templates/results-artist.html',
		controller: 'ResultsArtistCtrl'
      }
    }
  })
  
  .state('app.results_rhythm', {
    url: '/results/:rhythm',
    views: {
      'menuContent': {
        templateUrl: 'templates/results-rhythm.html',
		controller: 'ResultsRhythmCtrl'
      }
    }
  })

  .state('app.favouritelists', {
      url: '/favouritelists',
      views: {
        'menuContent': {
          templateUrl: 'templates/favouritelists.html',
		  controller: 'FavouritelistsCtrl'
        }
      }
    })
    .state('app.songlists', {
      url: '/songlists',
      views: {
        'menuContent': {
          templateUrl: 'templates/songlists.html',
          controller: 'SonglistsCtrl'
        }
      }
    })

  .state('app.detail', {
    url: '/songlists/:songId',
    views: {
      'menuContent': {
        templateUrl: 'templates/detail.html',
        controller: 'DetailCtrl'
      }
    }
  })
    
  .state('app.settings', {
    url: '/settings',
    views: {
      'menuContent': {
        templateUrl: 'templates/settings.html',
        controller: 'SettingsCtrl'
      }
    }
  })
  
    .state('app.help', {
    url: '/help',
    views: {
      'menuContent': {
        templateUrl: 'templates/help.html',
        controller: 'HelpCtrl'
      }
    }
  });
    
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/search');
});




