angular.module('Hopamviet.controllers', ['ngCordova', 'Hopamviet.services'])

.controller('AppCtrl', function($scope, $ionicModal, $timeout) {
  
})

.controller('SonglistsCtrl', function($scope, DataManager, $state, $q, $ionicScrollDelegate) {
    $scope.playlists = []; 
    $scope.isMoreData = true;
    $scope.searchType = '0';
    
    
     $scope.options = [
            {id: 0, text: 'Mới cập nhật', checked: true, icon: null}, 
            {id: 1, text: 'Mới xem gần đây', checked: false, icon: null}, 
            {id : 2, text: 'Bài hát ngẫu nhiên', checked: false, icon: null}];
  
 
    $scope.val =  {single: 0, multiple: null};
    
  $scope.$watch("val.single", function(newValue, oldValue){
    console.log("val.single = " + newValue);
    $scope.selectChange(newValue);
  });
    
    $scope.$on('$ionicView.enter',function(){       
       $scope.playlists = [];           
       $scope.loadMore();
        
    });
	 
    $scope.selectChange = function(searchType){
        $scope.searchType = searchType;
        console.log("searchType = " + searchType);
        $scope.playlists = [];           
        $scope.loadMore();
        $ionicScrollDelegate.scrollTop();
    }
    
    $scope.refreshSongList = function(songlist){
       var promises = [];
        for(var i = 0; i < songlist.length; i++){               
            var promise = DataManager.getChordBySongId(songlist[i].song_id);
            promises.push(promise);
        }

        $q.all(promises).then(function(results){               
            for(var i = 0; i < songlist.length; i++){  
                songlist[i].chords = results[i];
            }

            $scope.playlists.push.apply($scope.playlists, songlist);
            $scope.isMoreData = songlist.length > 0;
            $scope.$broadcast('scroll.infiniteScrollComplete');	            
        }); 
    }
    
	$scope.loadMore = function() {
        if($scope.searchType == 0){
            DataManager.getSongListByOffset($scope.playlists.length).then(function(songlist){   
               $scope.refreshSongList(songlist);            	
            });			
        } else if($scope.searchType == 1){
            DataManager.getLastviewSongListByOffset($scope.playlists.length).then(function(songlist){   
               $scope.refreshSongList(songlist);            	
            });	
        } else {
            DataManager.getSongNumber().then(function(count){                                
                var offset = Math.floor(Math.random() * count);
                console.log("Random offset = " + offset);
                DataManager.getSongListByOffset(offset).then(function(songlist){   
                   $scope.refreshSongList(songlist);            	
                });	
            });    
               
        }
	};
	
     $scope.search = function() {
        $state.go("app.search");
    }
		
	$scope.toggleFavorite = function($event, playlist) {
		console.log("toggleFavorite");
		playlist.song_isfavorite = (playlist.song_isfavorite == 0) ? 1 : 0;
		DataManager.updateFavoriteSongById(playlist.song_isfavorite,playlist.song_id);	
        $event.stopImmediatePropagation();
	}
    
    $scope.clickItem = function(playlist){
        console.log("clickItem");
        $state.go("app.detail",{"songId" :playlist.song_id});
    }
    
    
	
 })

.controller('FavouritelistsCtrl', function($scope, DataManager, $state, $q) {
  $scope.$on('$ionicView.enter', function() {
     // Code you want executed every time view is opened
     $scope.playlists = [];
     DataManager.getFavoriteSongList().then(function(songlist){
         var promises = [];
        for(var i = 0; i < songlist.length; i++){               
            var promise = DataManager.getChordBySongId(songlist[i].song_id);
            promises.push(promise);
        }

        $q.all(promises).then(function(results){               
            for(var i = 0; i < songlist.length; i++){  
                songlist[i].chords = results[i];
            }

            $scope.playlists = songlist;
        });  
		
	 }); 
  })
    
    $scope.search = function() {
        $state.go("app.search");
    }
     
	$scope.toggleFavorite = function($event, playlist) {
		console.log("toggleFavorite");
		playlist.song_isfavorite = (playlist.song_isfavorite == 0) ? 1 : 0;
		DataManager.updateFavoriteSongById(playlist.song_isfavorite,playlist.song_id);	
        $event.stopImmediatePropagation();
	}
    
    $scope.clickItem = function(playlist){
        console.log("clickItem");
        $state.go("app.detail",{"songId" :playlist.song_id});
    }
})

.controller('ResultsCtrl', function($scope, $stateParams, DataManager, $state, $q) {

  $scope.txtSearch = $stateParams.txtSearch;
  $scope.searchType = '0';
  $scope.isMoreData = true;
  
    $scope.options = [
            {id: 0, text: 'Tìm theo bài hát', checked: true, icon: null}, 
            {id: 1, text: 'Tác giả / Ca sĩ', checked: false, icon: null} 
          ];
  
 
    $scope.val =  {single: 0, multiple: null};
    
  $scope.$watch("val.single", function(newValue, oldValue){
    console.log("val.single = " + newValue);
    $scope.selectChange(newValue);
  });
    
   
          
    $scope.playlists = []; 
    
    $scope.$on('$ionicView.enter',function(){
       
       $scope.playlists = [];           
       $scope.loadMore();
        
    });
    
  

    $scope.selectChange = function(searchType){
        $scope.searchType = searchType;
        console.log("searchType = " + searchType);
        if(searchType == 0){
            $scope.playlists = [];           
            $scope.loadMore(); 
        }else {
            DataManager.searchArtist_Author($scope.txtSearch).then(function(songlist){
                $scope.playlists_Author = songlist;
            });
            
            DataManager.searchArtist_Singger($scope.txtSearch).then(function(songlist){
                $scope.playlists_Singer = songlist;
            });
        }
    }
    
    $scope.loadMore = function() {
        if($scope.searchType == 0){
            DataManager.searchSongByOffset($scope.txtSearch, $scope.playlists.length).then(function(songlist){		
                var promises = [];
                for(var i = 0; i < songlist.length; i++){               
                    var promise = DataManager.getChordBySongId(songlist[i].song_id);
                    promises.push(promise);
                }

                $q.all(promises).then(function(results){               
                    for(var i = 0; i < songlist.length; i++){  
                        songlist[i].chords = results[i];
                    }

                    $scope.playlists.push.apply($scope.playlists, songlist);
                    $scope.isMoreData = songlist.length > 0;
                    $scope.$broadcast('scroll.infiniteScrollComplete');	
                });
                
               		
            });	
        }else {
            $scope.isMoreData = false;
        }
	};
  	    
    
	$scope.toggleFavorite = function($event, playlist) {
		console.log("toggleFavorite");
		playlist.song_isfavorite = (playlist.song_isfavorite == 0) ? 1 : 0;
		DataManager.updateFavoriteSongById(playlist.song_isfavorite,playlist.song_id);	
        $event.stopImmediatePropagation();
	}
    
    $scope.clickItem = function(playlist){
        console.log("clickItem");
        $state.go("app.detail",{"songId" :playlist.song_id});
    }
    
    $scope.clickItem_Artist_Author = function(artist){
        console.log("clickItem_Artist");        
        $state.go("app.results_artist",{"artistId" :artist.artist_id, "type":"Author"});         
    }   
     
    $scope.clickItem_Artist_Singer = function(artist){
        console.log("clickItem_Artist");        
        $state.go("app.results_artist",{"artistId" :artist.artist_id, "type":"Singer"});         
    } 
    
})

.controller('ResultsArtistCtrl', function($scope, $stateParams, DataManager, $state, $q){
     $scope.artistId = $stateParams.artistId;  
     $scope.type = $stateParams.type;
     $scope.playlists = [];
     $scope.isLoadMore = true;
    
    $scope.$on('$ionicView.enter', function() {
        DataManager.getArtistById($scope.artistId).then(function(artist){
            $scope.artistName = artist.artist_name;
        });  
        
        $scope.playlists = [];
        $scope.loadMore();
        
        
        
    });
               
        
	
	$scope.toggleFavorite = function($event, playlist) {
		console.log("toggleFavorite");
		playlist.song_isfavorite = (playlist.song_isfavorite == 0) ? 1 : 0;
		DataManager.updateFavoriteSongById(playlist.song_isfavorite,playlist.song_id);	
        $event.stopImmediatePropagation();
	}
    
    $scope.clickItem = function(playlist){
        console.log("clickItem");
        $state.go("app.detail",{"songId" :playlist.song_id});
    }
    
    $scope.loadMore = function(){
               
        if($scope.type == "Author"){
            DataManager.searchSongByArtist_AuthorByOffset($scope.artistId, $scope.playlists.length).then(function(songlist){
                var promises = [];
                for(var i = 0; i < songlist.length; i++){               
                    var promise = DataManager.getChordBySongId(songlist[i].song_id);
                    promises.push(promise);
                }

                $q.all(promises).then(function(results){               
                    for(var i = 0; i < songlist.length; i++){  
                        songlist[i].chords = results[i];
                    }

                    $scope.playlists.push.apply($scope.playlists, songlist);
                    $scope.isMoreData = songlist.length > 0;
                    $scope.$broadcast('scroll.infiniteScrollComplete');	
                });                
               
            });
        } else {
            DataManager.searchSongByArtist_SingerByOffset($scope.artistId, $scope.playlists.length).then(function(songlist){
                var promises = [];
                for(var i = 0; i < songlist.length; i++){               
                    var promise = DataManager.getChordBySongId(songlist[i].song_id);
                    promises.push(promise);
                }

                $q.all(promises).then(function(results){               
                    for(var i = 0; i < songlist.length; i++){  
                        songlist[i].chords = results[i];
                    }

                    $scope.playlists.push.apply($scope.playlists, songlist);
                    $scope.isMoreData = songlist.length > 0;
                    $scope.$broadcast('scroll.infiniteScrollComplete');	
                });
               
            });      
        }
    }
})

.controller('ResultsRhythmCtrl',function($scope, $stateParams, DataManager, $state, $q){
    $scope.rhythm = $stateParams.rhythm;     
    $scope.isMoreData = true;
  
    $scope.playlists = []; 
    
    $scope.$on('$ionicView.enter',function(){       
       $scope.playlists = [];           
       $scope.loadMore();        
    });
    
    $scope.loadMore = function() {        
        DataManager.searchSongWithRhytmhByOffset($scope.rhythm, $scope.playlists.length).then(function(songlist){
            var promises = [];
            for(var i = 0; i < songlist.length; i++){               
                var promise = DataManager.getChordBySongId(songlist[i].song_id);
                promises.push(promise);
            }

            $q.all(promises).then(function(results){               
                for(var i = 0; i < songlist.length; i++){  
                    songlist[i].chords = results[i];
                }

                $scope.playlists.push.apply($scope.playlists, songlist);
                $scope.isMoreData = songlist.length > 0;
                $scope.$broadcast('scroll.infiniteScrollComplete');	
            });            
           		
        });	       
	};
    
    $scope.toggleFavorite = function($event, playlist) {
		console.log("toggleFavorite");
		playlist.song_isfavorite = (playlist.song_isfavorite == 0) ? 1 : 0;
		DataManager.updateFavoriteSongById(playlist.song_isfavorite,playlist.song_id);	
        $event.stopImmediatePropagation();
	}
    
    $scope.clickItem = function(playlist){
        console.log("clickItem");
        $state.go("app.detail",{"songId" :playlist.song_id});
    }
    
})

.controller('DetailCtrl', function($scope, $stateParams, DataManager, Utils, $state, $ionicModal,$ionicPlatform, $cordovaSocialSharing, $cordovaFacebook, $cordovaNetwork) {
    $scope.id = $stateParams.songId;
    $scope.isSplitLine = true;
    $scope.currentAmount = 0;
    
    
    
	DataManager.getSongById($scope.id).then(function(song){
        $scope.song = song;        
		$scope.title = song.song_title;
		$scope.lyric = song.song_content;
		$scope.rhythm = song.song_rhythm;	
               
        if($scope.rhythm != null){         
            $scope.rhythm = Utils.capitalizeFirstLetter($scope.rhythm);
        }else {
            $scope.rhythm = "N/A";	
        }
        
        $scope.lyric1 = Utils.getLyric1Lines($scope.lyric);	
        $scope.lyric2 = Utils.getLyric2Lines($scope.lyric);
        
        DataManager.updateLastViewSongById(song.song_id);
              
	});   
    
            
    
    DataManager.getAuthorBySongId($scope.id).then(function(author){
       $scope.author = author;
    });
    
    DataManager.getSingerBySongId($scope.id).then(function(singer){
        $scope.singer = singer;
    });
    
    
    
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
    
    $scope.$on('$ionicView.enter',function(){       
       $ionicModal.fromTemplateUrl('modal.html', function($ionicModal) {
            $scope.modal = $ionicModal;


        }, {
            // Use our scope for the scope of the modal to keep it simple
            scope: $scope,
            // The animation we want to use for the modal entrance
            animation: 'slide-in-up'
        });        
    });
    
    $scope.viewChange = function(){
        $scope.currentAmount = 0;        
    }
    
    $scope.changeAllChord = function(amount){
        $('.border span.hopamchuan_chord').each(function(){
            var obj = $(this);    
            obj.html(jtab.transposeChord(obj.html(), amount));
        });
        
       
        $scope.currentAmount += amount;
        console.log("currentAmount = " + $scope.currentAmount);
        if ($scope.currentAmount == 12) $scope.currentAmount = 0;
        if ($scope.currentAmount == -1) $scope.currentAmount = 11;
    }
    
   $scope.clickChordView = function($event){
       //console.log("clickChordView");
       $event.stopImmediatePropagation();
   }
   
   $scope.clickChord = function($event){
       console.log("clickChord");  
       
       var obj = $($event.currentTarget);          
           var pos = obj.offset();

            $scope.modal.show();
            
            var chord = $event.currentTarget.innerHTML;
            chord = chord.replace(/\]/g,'');
            chord = chord.replace(/\[/g,'');
            
            jtab.render($('#chord_view #draw_chord'),chord);         
            
            console.log(chord);
            
            var top = pos.top - 180;
            var left = pos.left - 70;
            
            var bodyW = $('body').width;
            var chordW = $('#chord_view').width;
            
            if(left + chordW > bodyW){
                left = bodyW - chordW - 10;
            }
            
            
            $('#chord_view').css({
                            position: "absolute", 
                             top: (top > 0 ? top : 0) + "px",
                            left: (left > 0 ? left : 0) + "px"
                        });
       
   }
    
    
		
	
	$scope.toggleFavorite = function($event, song) {
		console.log("toggleFavorite");
		song.song_isfavorite = (song.song_isfavorite == 0) ? 1 : 0;
		DataManager.updateFavoriteSongById(song.song_isfavorite,song.song_id);	
        $event.stopImmediatePropagation();
	}
	
    $scope.clickItem_Artist_Author = function(artist){
        console.log("clickItem_Artist");        
        $state.go("app.results_artist",{"artistId" :artist.artist_id, "type":"Author"});         
    }   
     
    $scope.clickItem_Artist_Singer = function(artist){
        console.log("clickItem_Artist");        
        $state.go("app.results_artist",{"artistId" :artist.artist_id, "type":"Singer"});         
    } 
    
    $scope.clickItem_Rhythm = function(song){
        console.log("clickItem_Rhythm");
        $state.go("app.results_rhythm",{"rhythm" :song.song_rhythm}); 
    }
	
    $scope.playSong = function(){
        var isOffline  = $cordovaNetwork.isOffline();
        if(isOffline){
            alert("Bạn chưa kết nối internet !");
            return;
        }
        
        window.open($scope.song.song_link, '_system', 'location=yes');
        return false;
    }
    
   
    
    $scope.search = function() {
        $state.go("app.search");
    }
    
     $scope.shareViaFacebook = function() {
         var isOffline  = $cordovaNetwork.isOffline();
        if(isOffline){
            alert("Bạn chưa kết nối internet !");
            return;
        }
         
         var description = $scope.lyric;         
         var link = $scope.song.song_link;   
         var name = $scope.title + " - " + $scope.author.artist_name;
         var caption = "Gửi từ ứng dụng : HopAmViet";
         
         var options = { 
            method : "share", 
            link : link, //this is used for share dialog 
            //href : "http://xethangbang.vn", //this is used for feed dialog            
            description : description, 
            name : name, 
            caption : caption, 
            picture : "https://stevennguyen161.files.wordpress.com/2016/03/hopamviet-logo.png" 
        };
         
         
       
        
         
         $cordovaFacebook.getLoginStatus().then(function(response){
            if (response.status === 'connected') {
                $cordovaFacebook.showDialog(options).then(
                    function(result){  console.log(JSON.stringify(result));     },
                    function(error){   console.log(JSON.stringify(error));      });
            }else {
                $cordovaFacebook.login(["public_profile", "email", "user_friends"])
                .then(function(success) { 
                    $cordovaFacebook.showDialog(options).then(
                        function(result){   console.log(JSON.stringify(result));  },
                        function(error){    console.log(JSON.stringify(error));   });
                }, function(error){
                    console.log(JSON.stringify(error));                    
                });
            }
          });
         
       
    }
    
		
})

.controller('SearchCtrl', function($scope, $cordovaSQLite, Database,  $state, DataManager ) {
  
  $scope.searchHint = [];
  
    
  $scope.search = function(txtSearch) {
	console.log("search");
	console.log(txtSearch);
	$state.go("app.results",{"txtSearch" :txtSearch});	
  }
  
  $scope.searchChange = function(txtSearch){      
      
      if(txtSearch.length < 3){
          $scope.searchHint = [];
          return;
      }    
      
      
      DataManager.searchSongByOffset(txtSearch, 0).then(function(songlist){
         $scope.searchHint =  songlist.slice(0,5);         
      });
  }
  
  $scope.clickItem = function(playlist){
        console.log("clickItem");
        $state.go("app.detail",{"songId" :playlist.song_id});
    }
  
  $scope.clickContent = function(){
       $scope.searchHint = [];
  } 
  
 })

.controller('SettingsCtrl', function($scope, $cordovaEmailComposer, $cordovaFacebook, $cordovaNetwork){
    $scope.text = "Helo SettingsCtrl";
    $scope.user = null;
   
    $scope.updateLoginStatus = function(){        
         
        $cordovaFacebook.getLoginStatus(
            function(response){
                if(response.status === 'connected'){
                    $scope.logged_in = true;
                     $scope.getUserInfo();
                }else{
                    $scope.logged_in = false;
                }
            },
            function(err){
                $scope.logged_in = false;
                console.log('Error while trying to check login status');                
            }
        );
    };


    $scope.getUserInfo = function(){

        $cordovaFacebook.api(
            "me/?fields=id,email,first_name,last_name,gender,age_range",
            ['public_profile', 'email']).then(
            function (response) {
                console.log(JSON.stringify(response));               
                $scope.user = response;
                
                $scope.getUserPictureUrl();
                
            },
            function (error) {
                console.log("Failed: " + error);
            }
        );
    };
    
    $scope.getUserPictureUrl = function(){

        $cordovaFacebook.api(
            $scope.user.id + "/?fields=picture",['public_profile', 'email']).then(
            function (response) {
                console.log(JSON.stringify(response));               
                $scope.user.picture_url = response.picture.data.url;
                
            },
            function (error) {
                console.log("Failed: " + error);
            }
        );
    };
    
    
    
        $scope.fbLogin = function(){
            var isOffline  = $cordovaNetwork.isOffline();
            if(isOffline){
                alert("Bạn chưa kết nối internet !");
                return;
            }
            
             $cordovaFacebook.login(["public_profile", "email", "user_friends"]).then(
                function(response){
                    $scope.logged_in = true;
                    console.log('logged in successfully');
                    console.log(JSON.stringify(response.authResponse));                    
                                  
                    $scope.getUserInfo();
                    
                }, function(err){                
                    console.log('an error occured while trying to login. please try again.');
                });


        };


        $scope.fbLogout = function(){
            var isOffline  = $cordovaNetwork.isOffline();
            if(isOffline){
                alert("Bạn chưa kết nối internet !");
                return;
            }
            
            facebookConnectPlugin.logout().then(
                function(response){
                    console.log(JSON.stringify(response));   
                    $scope.logged_in = false;
                },
                function(err){
                    console.log(JSON.stringify(err));                   
                }
            );

        };

    
    
})
            
.controller('HelpCtrl', function($scope, $cordovaEmailComposer){
    
    
    $scope.gotoWebsite = function(link){
        window.open(link, '_system', 'location=yes');
        return false;
    }
    
    
    $scope.sendEmail = function(){
        
        $cordovaEmailComposer.isAvailable().then(function() {
           console.log("$cordovaEmailComposer is available");
         }, function () {
            console.log("$cordovaEmailComposer is NOT available"); 
            return;
         });
        
        var email = {
            to: 'steven.nguyen161@gmail.com',        
            subject: 'Góp ý về Ứng dụng - Hop Am Viet',
            body: 'Ý kiến của bạn',
            isHtml: true
          };
    
    
    
        $cordovaEmailComposer.open(email).then(null, function () {
            console.log("user cancelled email");   
        });  
    }
    
    
      
});


